# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b897"
os.chdir("/home/notebook/sage_notebook/worksheets/admin/16/cells/2")
sage.server.notebook.interact.SAGE_CELL_ID=2
standard_deck = [Integer(2),Integer(2),Integer(2),Integer(2),Integer(3),Integer(3),Integer(3),Integer(3),Integer(4),Integer(4),Integer(4),Integer(4),Integer(5),Integer(5),Integer(5),Integer(5),Integer(6),Integer(6),Integer(6),Integer(6),Integer(7),Integer(7),Integer(7),Integer(7),Integer(8),Integer(8),Integer(8),Integer(8),Integer(9),Integer(9),Integer(9),Integer(9),
Integer(10),Integer(10),Integer(10),Integer(10),Integer(11),Integer(11),Integer(11),Integer(11),Integer(12),Integer(12),Integer(12),Integer(12),Integer(13),Integer(13),Integer(13),Integer(13),Integer(14),Integer(14),Integer(14),Integer(14)]
def play_war(show_cards=True, output=True, shuffle=True, deck=standard_deck):
    #shuffle deck
    if shuffle:
        for i in (ellipsis_range(len(deck)-Integer(1),len(deck)-Integer(2),Ellipsis,Integer(0))):
            index = randint(Integer(0),i)
            card = deck[index]
            deck.append(card)
            deck.pop(index)
    #end of shuffle

    #deal the cards
    hand1 = []
    hand2 = []
    for j in (ellipsis_range(Integer(0),Integer(2),Ellipsis,len(deck)-Integer(2))):
        hand1.append(deck[j])
        hand2.append(deck[j+Integer(1)])
    #end of deal

    if show_cards:
        print "Initially shuffled deck:"
        print deck
        print ""
        print "Player 1's starting hand:"
        print hand1
        print ""
        print "Player 2's starting hand:"
        print hand2

    #initialize game stats
    tie = False
    wars = [Integer(0),Integer(0),Integer(0),Integer(0),Integer(0),Integer(0),Integer(0),Integer(0),Integer(0),Integer(0),Integer(0),Integer(0),Integer(0),Integer(0)]

    while len(hand1) > Integer(0) and len(hand2) > Integer(0) and not tie:
        index = Integer(0)
        if hand1 == hand2:
            tie = True
        if hand1[Integer(0)] > hand2[Integer(0)]:    #player 1 wins the battle
            hand1.append(hand2[Integer(0)])
            hand1.append(hand1[Integer(0)])
            hand1[:Integer(1)] = []
            hand2[:Integer(1)] = []
        elif hand2[Integer(0)] > hand1[Integer(0)]:  #player 2 wins the battle
            hand2.append(hand1[Integer(0)])
            hand2.append(hand2[Integer(0)])
            hand2[:Integer(1)] = []
            hand1[:Integer(1)] = []
        else:                      #a war occurs!
            if len(hand1) <= Integer(2):    #player 1 runs out of cards during the war
                exit = Integer(1)
                hand1 = []
            elif len(hand2) <= Integer(2):  #player 2 runs out of cards during the war
                exit = Integer(1)
                hand2 = []
            else:
                exit = Integer(0)
            while exit == Integer(0) and hand1[index] == hand2[index]:  #provision for multi-wars
                index += Integer(2)
                if index > len(hand1)-Integer(1):    #player 1 runs out of cards during the war
                    exit = Integer(1)
                    hand1 = []
                elif index > len(hand2)-Integer(1):  #player 2 runs out of cards during the war
                    exit = Integer(1)
                    hand2 = []
            if exit == Integer(0) and hand1[index] > hand2[index]:    #player 1 wins the war
                for i in (ellipsis_range(Integer(0),Ellipsis,index)):
                    hand1.append(hand2[Integer(0)])
                    hand1.append(hand1[Integer(0)])
                    hand1[:Integer(1)] = []
                    hand2[:Integer(1)] = []
            elif exit == Integer(0) and hand2[index] > hand1[index]:  #player 2 wins the war
                for i in (ellipsis_range(Integer(0),Ellipsis,index)):
                    hand2.append(hand1[Integer(0)])
                    hand2.append(hand2[Integer(0)])
                    hand2[:Integer(1)] = []
                    hand1[:Integer(1)] = []
        wars[index/Integer(2)] += Integer(1)
    if output:
        print ""
        if tie or not wars[Integer(13)] == Integer(0): print "The game is a draw."
        elif len(hand1) > len(hand2): print "Player 1 wins."
        else: print "Player 2 wins."
        print "Total number of battles:", wars[Integer(0)]
        sum = Integer(0)
        for i in (ellipsis_range(Integer(1),Ellipsis,Integer(13))):
            sum += wars[i]
        print "Total number of wars:", sum
        for i in (ellipsis_range(Integer(1),Ellipsis,Integer(13))):
            if not wars[i] == Integer(0): print "Number of "+str(i)+"-wars:", wars[i]
        print ""

print "e897"
